package com.ashokit.order.service;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ashokit.order.dto.OrchestratorResponseDTO;
import com.ashokit.order.repo.PurchaseOrderRespository;

import reactor.core.publisher.Mono;

@Service
public class UpdateService {

	@Autowired
	private PurchaseOrderRespository repo;
	
	public Mono<Void> updateOrder(OrchestratorResponseDTO responseDTO) {
		System.out.println("Response::"+responseDTO.getStatus());
		
		
		 return repo.findById(responseDTO.getOrderId())
		.doOnNext(p -> p.setStatus(responseDTO.getStatus()))
		.doOnNext(repo::save)
		.then(); 
		
		
	}
	
	
}
